% learning_clafic.m wKԖ@
clear
close all

r=1;     % Ԃ̎(eNX, 1<=r<=9)
alp=0.1; % wKW (0<alp<1)

load('traiX.mat');    % traĩIWi摜ƃx̓Ǎ
load('queryX.mat');   % querỹIWi摜ƃx̓Ǎ

nclass=40; % NX
[d ntrai] =size(trai.X);   % 摜̎dƌP摜ntrai
[d nquery]=size(query.X);  % 摜̎dƃeXg摜nquery

% Ԃ̒n̎Zo
for jj = 1 : nclass
	% xjǰP摜YɊi[
	X=trai.X(:,find(trai.label==jj));
	[d n] = size(X);           % X̃TCY擾 n<<d
	N = X'*X;                  % n x n̏sNvZ
	rdim = rank(N);            % N̊KZo

	% ŗLxNgׂsU̎Zo
	[eig_vec eig_val] = eig(N); % ŇŗLlƌŗLxNg߂
	[value index]=sort(diag(eig_val),'descend'); % ŗLl~ɕבւ
	U = X * eig_vec(:,index(1:rdim)) * diag(sqrt(1./value(1:rdim)) );

	C(jj).U  = U; % NXjǰŗLxNg
	fprintf(2,'class %d --- ok\n',jj);
end

%% wK
s=zeros(nclass,1);         % ގxi[pϐ
MAX_ITE=100;               % őwK
obj_func=zeros(MAX_ITE,1); % wKXebvƂ̎ʗ

% Ȕ
for jj = 1 : nclass
	LC(jj).U=C(jj).U(:,1:r);
end

for t=1:MAX_ITE

	% Cʗpϐ̏
	for jj = 1 : nclass
		dC(jj).U=zeros(d,r);
  end

	% P摜pĊwK
  for ii = 1 : ntrai
  	
  	% eNXƂ̗ގxvZ
  	for jj = 1 : nclass
  		s(jj)=norm((LC(jj).U)'*trai.X(:,ii)).^2;
  	end

  	% ގx~Ƀ\[g  	
  	[value index]=sort(s,'descend');
  	
  	% P摜̃xppɊi[
  	pp=trai.label(ii);
  	
  	% P摜̃xppɊi[
  	if index(1)~=trai.label(ii)
  		nn=index(1);  % 뎯ʂ̏ꍇ͂̃xnn
  	else
  		nn=index(2);  % ʂ̏ꍇ͓Ԗڂ̃NX̃xnn
    end
    
    % W̌vZ
    s1=s(pp);, s2=s(nn);
    u=(s2-s1)./(s1+s2);
    f=1./(1+exp(-u.*t));, df=alp.*t.*f.*(1-f);
    ds1=s2./(s1+s2).^2;, ds2=s1./(s1+s2).^2;
		
		% ]֐ľvZ
		obj_func(t)=obj_func(t)+f;

    % Cʂ̌vZ
    dC(pp).U=dC(pp).U+df.*ds1.*(trai.X(:,ii)*((trai.X(:,ii))'*LC(pp).U));
    dC(nn).U=dC(nn).U-df.*ds2.*(trai.X(:,ii)*((trai.X(:,ii))'*LC(nn).U));
	end
	
  fprintf(2,'learning step t = %3d, object function value =%f\n',t,obj_func(t));
	
	% ]֐̕ωȂI
	if t>1
		if abs(obj_func(t-1)-obj_func(t))<1E-5
			break;
		else
			% K
			for jj = 1 : nclass
				LC(jj).U=LC(jj).U+dC(jj).U;
				LC(jj).U=orth(LC(jj).U);
			end
		end
	else
		for jj = 1 : nclass
			LC(jj).U=LC(jj).U+dC(jj).U;
			LC(jj).U=orth(LC(jj).U);
		end
	end
end

% wK̃eXg摜̎ʗ
accuracy=0;             % ʗ
for ii = 1 : nquery
	% eNX̗ގxvZ
	for jj = 1 : nclass
		s(jj)=norm((LC(jj).U)'*query.X(:,ii));
	end
	% ގxőƂȂNX߂
	[value index]=max(s);
	% ގxőƂȂNXƃeXgf[^̃x
	if index==query.label(ii)
		accuracy=accuracy+1;
	end
end
% ʗSŕ\
accuracy=(accuracy./nquery).*100;
fprintf('dimensionality r=%d, accuracy : %2.1f \n',r,accuracy);
figure(1),clf,plot(obj_func(1:t));
xlabel('learning step t');, ylabel('Object function value');
